Ruby master - Bug #11603

Count trace_running for internal event
10/19/2015 02:47 PM - kOkubun (Takashi Kokubun)

Status: Closed

Priority: Normal

Assignee: ko1 (Koichi Sasada)

Target version:

ruby -v: ruby 2.3.0dev (2015-10-19 trunk 52192) | Backport: 2.0.0: UNKNOWN, 2.1: DONE, 2.2:
[x86_64-darwin14] DONE

Description

https://github.com/ruby/ruby/pull/1059

| want to fix a crash: https://gist.github.com/kOkubun/86fd9fbff32423bd4974

| noticed that clean_hooks can be executed inside exec_hooks_body.
The hooks of list->hooks can be xfreed during exec_hooks_body.
That's because th->vm->trace_running is not incremented for exec_hooks_unprotected.

So | fixed rb_threadptr_exec_event_hooks_orig to count exec_hooks_unprotected as th->vm->trace_running too.

Associated revisions

Revision 2d4bc584 - 11/07/2015 12:55 AM - ko1 (Koichi Sasada)

e vm_trace.c (rb_threadptr_exec_event_hooks_orig): maintain trace_running counter on internal events.

This patch is made by Takashi Kokubun takashikkbn@gmail.com.
[Bug #11603] https://github.com/ruby/ruby/pull/1059

git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/trunk@52476 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision 52476 - 11/07/2015 12:55 AM - ko1 (Koichi Sasada)

e vm_trace.c (rb_threadptr_exec_event_hooks_orig): maintain trace_running counter on internal events.

This patch is made by Takashi Kokubun takashikkbn@gmail.com.
[Bug #11603] https://github.com/ruby/ruby/pull/1059

Revision 52476 - 11/07/2015 12:55 AM - ko1 (Koichi Sasada)

e vm_trace.c (rb_threadptr_exec_event_hooks_orig): maintain trace_running counter on internal events.

This patch is made by Takashi Kokubun takashikkbn@gmail.com.
[Bug #11603] https:/github.com/ruby/ruby/pull/1059

Revision 52476 - 11/07/2015 12:55 AM - ko1 (Koichi Sasada)

e vm_trace.c (rb_threadptr_exec_event_hooks_orig): maintain trace_running counter on internal events.

This patch is made by Takashi Kokubun takashikkbn@gmail.com.
[Bug #11603] https:/github.com/ruby/ruby/pull/1059

Revision 52476 - 11/07/2015 12:55 AM - ko1 (Koichi Sasada)

¢ vm_trace.c (rb_threadptr_exec_event_hooks_orig): maintain trace_running counter on internal events.

This patch is made by Takashi Kokubun takashikkbn@gmail.com.
[Bug #11603] https://github.com/ruby/ruby/pull/1059

Revision 52476 - 11/07/2015 12:55 AM - ko1 (Koichi Sasada)
e vm_trace.c (rb_threadptr_exec_event_hooks_orig): maintain trace_running counter on internal events.

This patch is made by Takashi Kokubun takashikkbn@gmail.com.
[Bug #11603] https:/github.com/ruby/ruby/pull/1059

Revision 27635014 - 11/08/2015 02:49 PM - nagachika (Tomoyuki Chikanaga)
merge revision(s) 52476,52477: [Backport #11603]
* vm_trace.c (rb_threadptr_exec_event_hooks_orig):
maintain trace_running counter on internal events.

This patch is made by Takashi Kokubun <takashikkbn@gmail.com>.
[Bug #11603] https://github.com/ruby/ruby/pull/1059

* vm_trace.c (rb_threadptr_exec_event_hooks_orig):

git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/branches/ruby_2_ 2@52497 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision 52497 - 11/08/2015 02:49 PM - nagachika (Tomoyuki Chikanaga)

merge revision(s) 52476,52477: [Backport #11603]

* vm_trace.c (rb_threadptr_exec_event_hooks_orig):
maintain trace_running counter on internal events.

This patch is made by Takashi Kokubun <takashikkbn@gmail.com>.
[Bug #11603] https://github.com/ruby/ruby/pull/1059

* vm_trace.c (rb_threadptr_exec_event_hooks_orig):
Revision 3233891d - 11/18/2015 11:26 AM - usa (Usaku NAKAMURA)
merge revision(s) 52476,52477: [Backport #11603]
* vm_trace.c (rb_threadptr_exec_event_hooks_orig) :
maintain trace_running counter on internal events.
This patch is made by Takashi Kokubun <takashikkbn@gmail.com>.
[Bug #11603] https://github.com/ruby/ruby/pull/1059
* vm_trace.c (rb_threadptr_exec_event_hooks_orig):
git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/branches/ruby_2_1@52641 b2dd03c8-39d4-4d8f-98ff-823fe69b080e
Revision 52641 - 11/18/2015 11:26 AM - usa (Usaku NAKAMURA)
merge revision(s) 52476,52477: [Backport #11603]
* vm_trace.c (rb_threadptr_exec_event_hooks_orig) :
maintain trace_running counter on internal events.
This patch is made by Takashi Kokubun <takashikkbn@gmail.com>.

[Bug #11603] https://github.com/ruby/ruby/pull/1059

* vm_trace.c (rb_threadptr_exec_event_hooks_orig):

History

#1 - 10/20/2015 10:07 AM - sorah (Sorah Fukumori)

- Assignee set to ko1 (Koichi Sasada)

assigning ko1 at here too, because he has self-assigned at GitHub PR

#2 - 10/27/2015 05:28 PM - deivid (David Rodriguez)

Commenting here just to confirm that this change fixes the SEGVs that this patch introduces in byebug's test suite.

#3 - 11/05/2015 04:13 PM - kOkubun (Takashi Kokubun)

Byebug 7.0.0 including https://github.com/deivid-rodriguez/byebug/pull/160 is released to rubygems.org the day before yesterday.
Since byebug gem is installed by Rails' default Gemfile, | guess many users may have chance to cause this SEGV.

Could you review this and point out what is a blocker to merge this patch?

#4 - 11/07/2015 12:55 AM - ko1 (Koichi Sasada)
- Status changed from Open to Closed
Applied in changeset r52476.

e vm_trace.c (rb_threadptr_exec_event_hooks_orig): maintain trace_running counter on internal events.

This patch is made by Takashi Kokubun takashikkbn@gmail.com.
[Bug #11603] https:/github.com/ruby/ruby/pull/1059

#5 - 11/07/2015 12:51 PM - deivid (David Rodriguez)
- Backport changed from 2.0.0: UNKNOWN, 2.1: UNKNOWN, 2.2: UNKNOWN to 2.0.0: UNKNOWN, 2.1: REQUIRED, 2.2: REQUIRED

Great! Thanks a lot, Koichi!

We need backports to 2.1 and 2.2 if possible.

#6 - 11/08/2015 02:49 PM - nagachika (Tomoyuki Chikanaga)
- Backport changed from 2.0.0: UNKNOWN, 2.1: REQUIRED, 2.2: REQUIRED to 2.0.0: UNKNOWN, 2.1: REQUIRED, 2.2: DONE

Backported into ruby_2_2 branch at r52497.

#7 - 11/18/2015 11:26 AM - usa (Usaku NAKAMURA)
- Backport changed from 2.0.0: UNKNOWN, 2.1: REQUIRED, 2.2: DONE to 2.0.0: UNKNOWN, 2.1: DONE, 2.2: DONE

ruby_2_1r52641 merged revision(s) 52476,52477.

Files
ruby_2015-10-19-221406_P607.crash 18 KB 10/19/2015 kOkubun (Takashi Kokubun)
patch.diff 549 Bytes 10/19/2015 kOkubun (Takashi Kokubun)
